﻿function InitializeGrid(divId, GrdDBFields, GrdHdrs, GrdColType, GrdColSorting, GrdWidth, rowElemtName, HeaderAlign, isHideHeader) {
    var loDhtmlxGrd = new dhtmlXGridObject(divId);   
    return InitializeGridObj(loDhtmlxGrd, GrdDBFields, GrdHdrs, GrdColType, GrdColSorting, GrdWidth, rowElemtName, HeaderAlign, isHideHeader);
}
function InitializeGridObj(GridObj, GrdDBFields, GrdHdrs, GrdColType, GrdColSorting, GrdWidth, rowElemtName, HeaderAlign, isHideHeader)
{
    GridObj.setImagePath(GethdnImgUrl());
    GridObj.setColumnIds(GrdDBFields);
    GridObj.setHeader(GrdHdrs, null, HeaderAlign);
    GridObj.setColTypes(GrdColType);
    if (GrdColSorting != '')
    GridObj.setColSorting(GrdColSorting);
    GridObj.setInitWidths(ParseWidthToPercent(GrdWidth));
    GridObj.enableMultiline(true);
    Attach_CustomXML_Handler(GridObj, GrdDBFields, rowElemtName);
    if (isHideHeader)
        GridObj.setNoHeader(true);
    GridObj.init();
    GridObj.setSkin("dhx_skyblue");
    GridObj.enableAlterCss("grdItem", "uneven");
    GridObj.attachEvent("onMouseOver", function () { return false; });
    GridObj.enableColumnMove(false);
    return GridObj;
}
function Attach_CustomXML_Handler(grdObj, dataFields, rowElementName)
{
    grdObj._process_custom_xml = function (xml)
    {
        if (!xml.doXPath)
        {
            if (typeof (setRawXML) != "undefined")
                setRawXML(xml);
            var t = new dtmlXMLLoaderObject(function () { });
            t.loadXMLString(xml);
            xml = t;
        }
        else
        {
            if (typeof (setRawXML) != "undefined")
                setRawXML(xml.xmlDoc.responseXml.xml);
            //Handling error in Load Method using URL
            if ((xml.xmlDoc) && (xml.xmlDoc.responseXml.xml == ""))
            {
                var lsCheckErrText = NullToString(xml.xmlDoc.responseText);
                if (lsCheckErrText.indexOf("DHTMLxGridResponseError:Error") == 0)
                {
                    alert("System is unable to load data. Please contact administrator.");
                    return false;
                }
            }
        }

        this._parsing = true;
        var rows = xml.doXPath("//" + rowElementName);                     // get all row elements from XML

        for (var i = 0; i < rows.length; i++)
        {
            var id = this.getUID();                                // XML doesn't have native ids, so custom ones will be generated
            this.rowsBuffer[i] = {                                   // store references to each row element
                idd: id,
                data: rows[i],
                _parser: this._process_custom_xml_row //,   // cell parser method
                //_locator: this._get_custom_xml_data        // data locator method
            };

            this.rowsAr[id] = rows[i];                             // store id reference
        }
        this.render_dataset();                                   // force update of grid's view after data loading
        this._parsing = false;
    }
    grdObj._process_custom_xml_row = function (r, xml)
    {
        var size = this.xmlLoader.doXPath("./" + rowElementName, xml)[0];        // get size sub-tag
        var liCnt = 0;
        var TmpdataFileds = dataFields.split(",");
        var strAr = new Array();

        for (liCnt = 0; liCnt < TmpdataFileds.length; liCnt++)
        {
            if (xml.getAttribute(TmpdataFileds[liCnt]))
                strAr[liCnt] = xml.getAttribute(TmpdataFileds[liCnt]);
            else if (xml.getElementsByTagName(TmpdataFileds[liCnt])[0])
            {
                var lsDataContent = (xml.getElementsByTagName(TmpdataFileds[liCnt])[0]).text;
                if (lsDataContent)
                    strAr[liCnt] = lsDataContent;
                else
                    strAr[liCnt] = (xml.getElementsByTagName(TmpdataFileds[liCnt])[0]).textContent;
            }
        }

        // set just a plain array as no custom attributes are needed
        r._attrs = {};
        for (j = 0; j < r.childNodes.length; j++) r.childNodes[j]._attrs = {};

        // finish data loading 
        this._fillRow(r, strAr);
        return r;
    }
}
function ParseWidthToPercent(GrdWidth)
{
    if (GrdWidth == "")
        return;
    var widthArr = GrdWidth.split(",");
    var liCnt = 0;
    var retWidth = "";
    var ldAvailWidth = 0;
    var lIsAutoAdjust = false;
    var lAutoAdjustWidth = "0";
    var liTotalWidth = 0;
    if (document.forms[0].getAttribute("WindowType") == "ModalWindow")
        ldAvailWidth = 1024;
    else if (document.forms[0].getAttribute("AvailWidth"))
        ldAvailWidth = document.forms[0].getAttribute("AvailWidth");
    else
        ldAvailWidth = window.screen.width;

    for (liCnt = 0; liCnt < widthArr.length; liCnt++)
    {
        var ldPercentWidth;
        if (widthArr[liCnt] == "*")
            ldPercentWidth = "*";
        else if (widthArr[liCnt] == "0")
            ldPercentWidth = "0";
        else if (widthArr[liCnt] != "")
        {
            if (widthArr[liCnt].indexOf("~") > 0)
            {
                lIsAutoAdjust = true
                ldPercentWidth = "*";
                lAutoAdjustWidth = widthArr[liCnt].split("~")[0] / 100 * ldAvailWidth;
            }
            else
                ldPercentWidth = widthArr[liCnt] / 100 * ldAvailWidth;
        }
        if (liCnt == 0)
            retWidth = ldPercentWidth;
        else
            retWidth = retWidth + "," + ldPercentWidth;

        if (ldPercentWidth != "*" && ldPercentWidth != "")
            liTotalWidth += parseFloat(ldPercentWidth);
    }
    /*if ((lIsAutoAdjust) && (liTotalWidth > window.screen.width))
    {
        retWidth = retWidth.replace("*", lAutoAdjustWidth);
    }*/

    return retWidth;
}